"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isErrorWithLogs = exports.translateAndThrowAnchorError = void 0;
const cusper_1 = require("@metaplex-foundation/cusper");
const generated_1 = require("./generated");
const cusper = (0, cusper_1.initCusper)(generated_1.errorFromCode);
function translateAndThrowAnchorError(err) {
    var _a;
    if (!(0, exports.isErrorWithLogs)(err)) {
        throw err;
    }
    const translatedError = (_a = cusper.errorFromProgramLogs(err.logs)) !== null && _a !== void 0 ? _a : err;
    if (typeof Error.captureStackTrace === "function") {
        Error.captureStackTrace(translatedError, translateAndThrowAnchorError);
    }
    translatedError.logs = err.logs;
    throw translatedError;
}
exports.translateAndThrowAnchorError = translateAndThrowAnchorError;
const isErrorWithLogs = (err) => {
    return Boolean(err && typeof err === "object" && "logs" in err && Array.isArray(err.logs));
};
exports.isErrorWithLogs = isErrorWithLogs;
//# sourceMappingURL=errors.js.map