"use strict";
/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorFromName = exports.errorFromCode = exports.SpendingLimitInvalidAmountError = exports.BatchNotEmptyError = exports.TransactionNotLastInBatchError = exports.TransactionNotMatchingProposalError = exports.TransactionForAnotherMultisigError = exports.ProposalForAnotherMultisigError = exports.InvalidRentCollectorError = exports.RentReclamationDisabledError = exports.IllegalAccountOwnerError = exports.TimeLockExceedsMaxAllowedError = exports.ProtectedAccountError = exports.UnknownPermissionError = exports.DecimalsMismatchError = exports.SpendingLimitExceededError = exports.InvalidDestinationError = exports.InvalidMintError = exports.MissingAccountError = exports.NoActionsError = exports.TimeLockNotReleasedError = exports.NotSupportedForControlledError = exports.InvalidStaleTransactionIndexError = exports.NoExecutorsError = exports.NoProposersError = exports.NoVotersError = exports.RemoveLastMemberError = exports.InvalidAccountError = exports.InvalidNumberOfAccountsError = exports.AlreadyCancelledError = exports.AlreadyRejectedError = exports.AlreadyApprovedError = exports.InvalidTransactionIndexError = exports.InvalidProposalStatusError = exports.StaleProposalError = exports.InvalidTransactionMessageError = exports.NotAMemberError = exports.UnauthorizedError = exports.InvalidThresholdError = exports.TooManyMembersError = exports.EmptyMembersError = exports.DuplicateMemberError = void 0;
const createErrorFromCodeLookup = new Map();
const createErrorFromNameLookup = new Map();
/**
 * DuplicateMember: 'Found multiple members with the same pubkey'
 *
 * @category Errors
 * @category generated
 */
class DuplicateMemberError extends Error {
    constructor() {
        super('Found multiple members with the same pubkey');
        this.code = 0x1770;
        this.name = 'DuplicateMember';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DuplicateMemberError);
        }
    }
}
exports.DuplicateMemberError = DuplicateMemberError;
createErrorFromCodeLookup.set(0x1770, () => new DuplicateMemberError());
createErrorFromNameLookup.set('DuplicateMember', () => new DuplicateMemberError());
/**
 * EmptyMembers: 'Members array is empty'
 *
 * @category Errors
 * @category generated
 */
class EmptyMembersError extends Error {
    constructor() {
        super('Members array is empty');
        this.code = 0x1771;
        this.name = 'EmptyMembers';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, EmptyMembersError);
        }
    }
}
exports.EmptyMembersError = EmptyMembersError;
createErrorFromCodeLookup.set(0x1771, () => new EmptyMembersError());
createErrorFromNameLookup.set('EmptyMembers', () => new EmptyMembersError());
/**
 * TooManyMembers: 'Too many members, can be up to 65535'
 *
 * @category Errors
 * @category generated
 */
class TooManyMembersError extends Error {
    constructor() {
        super('Too many members, can be up to 65535');
        this.code = 0x1772;
        this.name = 'TooManyMembers';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, TooManyMembersError);
        }
    }
}
exports.TooManyMembersError = TooManyMembersError;
createErrorFromCodeLookup.set(0x1772, () => new TooManyMembersError());
createErrorFromNameLookup.set('TooManyMembers', () => new TooManyMembersError());
/**
 * InvalidThreshold: 'Invalid threshold, must be between 1 and number of members with Vote permission'
 *
 * @category Errors
 * @category generated
 */
class InvalidThresholdError extends Error {
    constructor() {
        super('Invalid threshold, must be between 1 and number of members with Vote permission');
        this.code = 0x1773;
        this.name = 'InvalidThreshold';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidThresholdError);
        }
    }
}
exports.InvalidThresholdError = InvalidThresholdError;
createErrorFromCodeLookup.set(0x1773, () => new InvalidThresholdError());
createErrorFromNameLookup.set('InvalidThreshold', () => new InvalidThresholdError());
/**
 * Unauthorized: 'Attempted to perform an unauthorized action'
 *
 * @category Errors
 * @category generated
 */
class UnauthorizedError extends Error {
    constructor() {
        super('Attempted to perform an unauthorized action');
        this.code = 0x1774;
        this.name = 'Unauthorized';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, UnauthorizedError);
        }
    }
}
exports.UnauthorizedError = UnauthorizedError;
createErrorFromCodeLookup.set(0x1774, () => new UnauthorizedError());
createErrorFromNameLookup.set('Unauthorized', () => new UnauthorizedError());
/**
 * NotAMember: 'Provided pubkey is not a member of multisig'
 *
 * @category Errors
 * @category generated
 */
class NotAMemberError extends Error {
    constructor() {
        super('Provided pubkey is not a member of multisig');
        this.code = 0x1775;
        this.name = 'NotAMember';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NotAMemberError);
        }
    }
}
exports.NotAMemberError = NotAMemberError;
createErrorFromCodeLookup.set(0x1775, () => new NotAMemberError());
createErrorFromNameLookup.set('NotAMember', () => new NotAMemberError());
/**
 * InvalidTransactionMessage: 'TransactionMessage is malformed.'
 *
 * @category Errors
 * @category generated
 */
class InvalidTransactionMessageError extends Error {
    constructor() {
        super('TransactionMessage is malformed.');
        this.code = 0x1776;
        this.name = 'InvalidTransactionMessage';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidTransactionMessageError);
        }
    }
}
exports.InvalidTransactionMessageError = InvalidTransactionMessageError;
createErrorFromCodeLookup.set(0x1776, () => new InvalidTransactionMessageError());
createErrorFromNameLookup.set('InvalidTransactionMessage', () => new InvalidTransactionMessageError());
/**
 * StaleProposal: 'Proposal is stale'
 *
 * @category Errors
 * @category generated
 */
class StaleProposalError extends Error {
    constructor() {
        super('Proposal is stale');
        this.code = 0x1777;
        this.name = 'StaleProposal';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, StaleProposalError);
        }
    }
}
exports.StaleProposalError = StaleProposalError;
createErrorFromCodeLookup.set(0x1777, () => new StaleProposalError());
createErrorFromNameLookup.set('StaleProposal', () => new StaleProposalError());
/**
 * InvalidProposalStatus: 'Invalid proposal status'
 *
 * @category Errors
 * @category generated
 */
class InvalidProposalStatusError extends Error {
    constructor() {
        super('Invalid proposal status');
        this.code = 0x1778;
        this.name = 'InvalidProposalStatus';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidProposalStatusError);
        }
    }
}
exports.InvalidProposalStatusError = InvalidProposalStatusError;
createErrorFromCodeLookup.set(0x1778, () => new InvalidProposalStatusError());
createErrorFromNameLookup.set('InvalidProposalStatus', () => new InvalidProposalStatusError());
/**
 * InvalidTransactionIndex: 'Invalid transaction index'
 *
 * @category Errors
 * @category generated
 */
class InvalidTransactionIndexError extends Error {
    constructor() {
        super('Invalid transaction index');
        this.code = 0x1779;
        this.name = 'InvalidTransactionIndex';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidTransactionIndexError);
        }
    }
}
exports.InvalidTransactionIndexError = InvalidTransactionIndexError;
createErrorFromCodeLookup.set(0x1779, () => new InvalidTransactionIndexError());
createErrorFromNameLookup.set('InvalidTransactionIndex', () => new InvalidTransactionIndexError());
/**
 * AlreadyApproved: 'Member already approved the transaction'
 *
 * @category Errors
 * @category generated
 */
class AlreadyApprovedError extends Error {
    constructor() {
        super('Member already approved the transaction');
        this.code = 0x177a;
        this.name = 'AlreadyApproved';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, AlreadyApprovedError);
        }
    }
}
exports.AlreadyApprovedError = AlreadyApprovedError;
createErrorFromCodeLookup.set(0x177a, () => new AlreadyApprovedError());
createErrorFromNameLookup.set('AlreadyApproved', () => new AlreadyApprovedError());
/**
 * AlreadyRejected: 'Member already rejected the transaction'
 *
 * @category Errors
 * @category generated
 */
class AlreadyRejectedError extends Error {
    constructor() {
        super('Member already rejected the transaction');
        this.code = 0x177b;
        this.name = 'AlreadyRejected';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, AlreadyRejectedError);
        }
    }
}
exports.AlreadyRejectedError = AlreadyRejectedError;
createErrorFromCodeLookup.set(0x177b, () => new AlreadyRejectedError());
createErrorFromNameLookup.set('AlreadyRejected', () => new AlreadyRejectedError());
/**
 * AlreadyCancelled: 'Member already cancelled the transaction'
 *
 * @category Errors
 * @category generated
 */
class AlreadyCancelledError extends Error {
    constructor() {
        super('Member already cancelled the transaction');
        this.code = 0x177c;
        this.name = 'AlreadyCancelled';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, AlreadyCancelledError);
        }
    }
}
exports.AlreadyCancelledError = AlreadyCancelledError;
createErrorFromCodeLookup.set(0x177c, () => new AlreadyCancelledError());
createErrorFromNameLookup.set('AlreadyCancelled', () => new AlreadyCancelledError());
/**
 * InvalidNumberOfAccounts: 'Wrong number of accounts provided'
 *
 * @category Errors
 * @category generated
 */
class InvalidNumberOfAccountsError extends Error {
    constructor() {
        super('Wrong number of accounts provided');
        this.code = 0x177d;
        this.name = 'InvalidNumberOfAccounts';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidNumberOfAccountsError);
        }
    }
}
exports.InvalidNumberOfAccountsError = InvalidNumberOfAccountsError;
createErrorFromCodeLookup.set(0x177d, () => new InvalidNumberOfAccountsError());
createErrorFromNameLookup.set('InvalidNumberOfAccounts', () => new InvalidNumberOfAccountsError());
/**
 * InvalidAccount: 'Invalid account provided'
 *
 * @category Errors
 * @category generated
 */
class InvalidAccountError extends Error {
    constructor() {
        super('Invalid account provided');
        this.code = 0x177e;
        this.name = 'InvalidAccount';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidAccountError);
        }
    }
}
exports.InvalidAccountError = InvalidAccountError;
createErrorFromCodeLookup.set(0x177e, () => new InvalidAccountError());
createErrorFromNameLookup.set('InvalidAccount', () => new InvalidAccountError());
/**
 * RemoveLastMember: 'Cannot remove last member'
 *
 * @category Errors
 * @category generated
 */
class RemoveLastMemberError extends Error {
    constructor() {
        super('Cannot remove last member');
        this.code = 0x177f;
        this.name = 'RemoveLastMember';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, RemoveLastMemberError);
        }
    }
}
exports.RemoveLastMemberError = RemoveLastMemberError;
createErrorFromCodeLookup.set(0x177f, () => new RemoveLastMemberError());
createErrorFromNameLookup.set('RemoveLastMember', () => new RemoveLastMemberError());
/**
 * NoVoters: 'Members don't include any voters'
 *
 * @category Errors
 * @category generated
 */
class NoVotersError extends Error {
    constructor() {
        super("Members don't include any voters");
        this.code = 0x1780;
        this.name = 'NoVoters';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NoVotersError);
        }
    }
}
exports.NoVotersError = NoVotersError;
createErrorFromCodeLookup.set(0x1780, () => new NoVotersError());
createErrorFromNameLookup.set('NoVoters', () => new NoVotersError());
/**
 * NoProposers: 'Members don't include any proposers'
 *
 * @category Errors
 * @category generated
 */
class NoProposersError extends Error {
    constructor() {
        super("Members don't include any proposers");
        this.code = 0x1781;
        this.name = 'NoProposers';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NoProposersError);
        }
    }
}
exports.NoProposersError = NoProposersError;
createErrorFromCodeLookup.set(0x1781, () => new NoProposersError());
createErrorFromNameLookup.set('NoProposers', () => new NoProposersError());
/**
 * NoExecutors: 'Members don't include any executors'
 *
 * @category Errors
 * @category generated
 */
class NoExecutorsError extends Error {
    constructor() {
        super("Members don't include any executors");
        this.code = 0x1782;
        this.name = 'NoExecutors';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NoExecutorsError);
        }
    }
}
exports.NoExecutorsError = NoExecutorsError;
createErrorFromCodeLookup.set(0x1782, () => new NoExecutorsError());
createErrorFromNameLookup.set('NoExecutors', () => new NoExecutorsError());
/**
 * InvalidStaleTransactionIndex: '`stale_transaction_index` must be <= `transaction_index`'
 *
 * @category Errors
 * @category generated
 */
class InvalidStaleTransactionIndexError extends Error {
    constructor() {
        super('`stale_transaction_index` must be <= `transaction_index`');
        this.code = 0x1783;
        this.name = 'InvalidStaleTransactionIndex';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidStaleTransactionIndexError);
        }
    }
}
exports.InvalidStaleTransactionIndexError = InvalidStaleTransactionIndexError;
createErrorFromCodeLookup.set(0x1783, () => new InvalidStaleTransactionIndexError());
createErrorFromNameLookup.set('InvalidStaleTransactionIndex', () => new InvalidStaleTransactionIndexError());
/**
 * NotSupportedForControlled: 'Instruction not supported for controlled multisig'
 *
 * @category Errors
 * @category generated
 */
class NotSupportedForControlledError extends Error {
    constructor() {
        super('Instruction not supported for controlled multisig');
        this.code = 0x1784;
        this.name = 'NotSupportedForControlled';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NotSupportedForControlledError);
        }
    }
}
exports.NotSupportedForControlledError = NotSupportedForControlledError;
createErrorFromCodeLookup.set(0x1784, () => new NotSupportedForControlledError());
createErrorFromNameLookup.set('NotSupportedForControlled', () => new NotSupportedForControlledError());
/**
 * TimeLockNotReleased: 'Proposal time lock has not been released'
 *
 * @category Errors
 * @category generated
 */
class TimeLockNotReleasedError extends Error {
    constructor() {
        super('Proposal time lock has not been released');
        this.code = 0x1785;
        this.name = 'TimeLockNotReleased';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, TimeLockNotReleasedError);
        }
    }
}
exports.TimeLockNotReleasedError = TimeLockNotReleasedError;
createErrorFromCodeLookup.set(0x1785, () => new TimeLockNotReleasedError());
createErrorFromNameLookup.set('TimeLockNotReleased', () => new TimeLockNotReleasedError());
/**
 * NoActions: 'Config transaction must have at least one action'
 *
 * @category Errors
 * @category generated
 */
class NoActionsError extends Error {
    constructor() {
        super('Config transaction must have at least one action');
        this.code = 0x1786;
        this.name = 'NoActions';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NoActionsError);
        }
    }
}
exports.NoActionsError = NoActionsError;
createErrorFromCodeLookup.set(0x1786, () => new NoActionsError());
createErrorFromNameLookup.set('NoActions', () => new NoActionsError());
/**
 * MissingAccount: 'Missing account'
 *
 * @category Errors
 * @category generated
 */
class MissingAccountError extends Error {
    constructor() {
        super('Missing account');
        this.code = 0x1787;
        this.name = 'MissingAccount';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MissingAccountError);
        }
    }
}
exports.MissingAccountError = MissingAccountError;
createErrorFromCodeLookup.set(0x1787, () => new MissingAccountError());
createErrorFromNameLookup.set('MissingAccount', () => new MissingAccountError());
/**
 * InvalidMint: 'Invalid mint'
 *
 * @category Errors
 * @category generated
 */
class InvalidMintError extends Error {
    constructor() {
        super('Invalid mint');
        this.code = 0x1788;
        this.name = 'InvalidMint';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidMintError);
        }
    }
}
exports.InvalidMintError = InvalidMintError;
createErrorFromCodeLookup.set(0x1788, () => new InvalidMintError());
createErrorFromNameLookup.set('InvalidMint', () => new InvalidMintError());
/**
 * InvalidDestination: 'Invalid destination'
 *
 * @category Errors
 * @category generated
 */
class InvalidDestinationError extends Error {
    constructor() {
        super('Invalid destination');
        this.code = 0x1789;
        this.name = 'InvalidDestination';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidDestinationError);
        }
    }
}
exports.InvalidDestinationError = InvalidDestinationError;
createErrorFromCodeLookup.set(0x1789, () => new InvalidDestinationError());
createErrorFromNameLookup.set('InvalidDestination', () => new InvalidDestinationError());
/**
 * SpendingLimitExceeded: 'Spending limit exceeded'
 *
 * @category Errors
 * @category generated
 */
class SpendingLimitExceededError extends Error {
    constructor() {
        super('Spending limit exceeded');
        this.code = 0x178a;
        this.name = 'SpendingLimitExceeded';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, SpendingLimitExceededError);
        }
    }
}
exports.SpendingLimitExceededError = SpendingLimitExceededError;
createErrorFromCodeLookup.set(0x178a, () => new SpendingLimitExceededError());
createErrorFromNameLookup.set('SpendingLimitExceeded', () => new SpendingLimitExceededError());
/**
 * DecimalsMismatch: 'Decimals don't match the mint'
 *
 * @category Errors
 * @category generated
 */
class DecimalsMismatchError extends Error {
    constructor() {
        super("Decimals don't match the mint");
        this.code = 0x178b;
        this.name = 'DecimalsMismatch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DecimalsMismatchError);
        }
    }
}
exports.DecimalsMismatchError = DecimalsMismatchError;
createErrorFromCodeLookup.set(0x178b, () => new DecimalsMismatchError());
createErrorFromNameLookup.set('DecimalsMismatch', () => new DecimalsMismatchError());
/**
 * UnknownPermission: 'Member has unknown permission'
 *
 * @category Errors
 * @category generated
 */
class UnknownPermissionError extends Error {
    constructor() {
        super('Member has unknown permission');
        this.code = 0x178c;
        this.name = 'UnknownPermission';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, UnknownPermissionError);
        }
    }
}
exports.UnknownPermissionError = UnknownPermissionError;
createErrorFromCodeLookup.set(0x178c, () => new UnknownPermissionError());
createErrorFromNameLookup.set('UnknownPermission', () => new UnknownPermissionError());
/**
 * ProtectedAccount: 'Account is protected, it cannot be passed into a CPI as writable'
 *
 * @category Errors
 * @category generated
 */
class ProtectedAccountError extends Error {
    constructor() {
        super('Account is protected, it cannot be passed into a CPI as writable');
        this.code = 0x178d;
        this.name = 'ProtectedAccount';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, ProtectedAccountError);
        }
    }
}
exports.ProtectedAccountError = ProtectedAccountError;
createErrorFromCodeLookup.set(0x178d, () => new ProtectedAccountError());
createErrorFromNameLookup.set('ProtectedAccount', () => new ProtectedAccountError());
/**
 * TimeLockExceedsMaxAllowed: 'Time lock exceeds the maximum allowed (90 days)'
 *
 * @category Errors
 * @category generated
 */
class TimeLockExceedsMaxAllowedError extends Error {
    constructor() {
        super('Time lock exceeds the maximum allowed (90 days)');
        this.code = 0x178e;
        this.name = 'TimeLockExceedsMaxAllowed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, TimeLockExceedsMaxAllowedError);
        }
    }
}
exports.TimeLockExceedsMaxAllowedError = TimeLockExceedsMaxAllowedError;
createErrorFromCodeLookup.set(0x178e, () => new TimeLockExceedsMaxAllowedError());
createErrorFromNameLookup.set('TimeLockExceedsMaxAllowed', () => new TimeLockExceedsMaxAllowedError());
/**
 * IllegalAccountOwner: 'Account is not owned by Multisig program'
 *
 * @category Errors
 * @category generated
 */
class IllegalAccountOwnerError extends Error {
    constructor() {
        super('Account is not owned by Multisig program');
        this.code = 0x178f;
        this.name = 'IllegalAccountOwner';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, IllegalAccountOwnerError);
        }
    }
}
exports.IllegalAccountOwnerError = IllegalAccountOwnerError;
createErrorFromCodeLookup.set(0x178f, () => new IllegalAccountOwnerError());
createErrorFromNameLookup.set('IllegalAccountOwner', () => new IllegalAccountOwnerError());
/**
 * RentReclamationDisabled: 'Rent reclamation is disabled for this multisig'
 *
 * @category Errors
 * @category generated
 */
class RentReclamationDisabledError extends Error {
    constructor() {
        super('Rent reclamation is disabled for this multisig');
        this.code = 0x1790;
        this.name = 'RentReclamationDisabled';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, RentReclamationDisabledError);
        }
    }
}
exports.RentReclamationDisabledError = RentReclamationDisabledError;
createErrorFromCodeLookup.set(0x1790, () => new RentReclamationDisabledError());
createErrorFromNameLookup.set('RentReclamationDisabled', () => new RentReclamationDisabledError());
/**
 * InvalidRentCollector: 'Invalid rent collector address'
 *
 * @category Errors
 * @category generated
 */
class InvalidRentCollectorError extends Error {
    constructor() {
        super('Invalid rent collector address');
        this.code = 0x1791;
        this.name = 'InvalidRentCollector';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidRentCollectorError);
        }
    }
}
exports.InvalidRentCollectorError = InvalidRentCollectorError;
createErrorFromCodeLookup.set(0x1791, () => new InvalidRentCollectorError());
createErrorFromNameLookup.set('InvalidRentCollector', () => new InvalidRentCollectorError());
/**
 * ProposalForAnotherMultisig: 'Proposal is for another multisig'
 *
 * @category Errors
 * @category generated
 */
class ProposalForAnotherMultisigError extends Error {
    constructor() {
        super('Proposal is for another multisig');
        this.code = 0x1792;
        this.name = 'ProposalForAnotherMultisig';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, ProposalForAnotherMultisigError);
        }
    }
}
exports.ProposalForAnotherMultisigError = ProposalForAnotherMultisigError;
createErrorFromCodeLookup.set(0x1792, () => new ProposalForAnotherMultisigError());
createErrorFromNameLookup.set('ProposalForAnotherMultisig', () => new ProposalForAnotherMultisigError());
/**
 * TransactionForAnotherMultisig: 'Transaction is for another multisig'
 *
 * @category Errors
 * @category generated
 */
class TransactionForAnotherMultisigError extends Error {
    constructor() {
        super('Transaction is for another multisig');
        this.code = 0x1793;
        this.name = 'TransactionForAnotherMultisig';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, TransactionForAnotherMultisigError);
        }
    }
}
exports.TransactionForAnotherMultisigError = TransactionForAnotherMultisigError;
createErrorFromCodeLookup.set(0x1793, () => new TransactionForAnotherMultisigError());
createErrorFromNameLookup.set('TransactionForAnotherMultisig', () => new TransactionForAnotherMultisigError());
/**
 * TransactionNotMatchingProposal: 'Transaction doesn't match proposal'
 *
 * @category Errors
 * @category generated
 */
class TransactionNotMatchingProposalError extends Error {
    constructor() {
        super("Transaction doesn't match proposal");
        this.code = 0x1794;
        this.name = 'TransactionNotMatchingProposal';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, TransactionNotMatchingProposalError);
        }
    }
}
exports.TransactionNotMatchingProposalError = TransactionNotMatchingProposalError;
createErrorFromCodeLookup.set(0x1794, () => new TransactionNotMatchingProposalError());
createErrorFromNameLookup.set('TransactionNotMatchingProposal', () => new TransactionNotMatchingProposalError());
/**
 * TransactionNotLastInBatch: 'Transaction is not last in batch'
 *
 * @category Errors
 * @category generated
 */
class TransactionNotLastInBatchError extends Error {
    constructor() {
        super('Transaction is not last in batch');
        this.code = 0x1795;
        this.name = 'TransactionNotLastInBatch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, TransactionNotLastInBatchError);
        }
    }
}
exports.TransactionNotLastInBatchError = TransactionNotLastInBatchError;
createErrorFromCodeLookup.set(0x1795, () => new TransactionNotLastInBatchError());
createErrorFromNameLookup.set('TransactionNotLastInBatch', () => new TransactionNotLastInBatchError());
/**
 * BatchNotEmpty: 'Batch is not empty'
 *
 * @category Errors
 * @category generated
 */
class BatchNotEmptyError extends Error {
    constructor() {
        super('Batch is not empty');
        this.code = 0x1796;
        this.name = 'BatchNotEmpty';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, BatchNotEmptyError);
        }
    }
}
exports.BatchNotEmptyError = BatchNotEmptyError;
createErrorFromCodeLookup.set(0x1796, () => new BatchNotEmptyError());
createErrorFromNameLookup.set('BatchNotEmpty', () => new BatchNotEmptyError());
/**
 * SpendingLimitInvalidAmount: 'Invalid SpendingLimit amount'
 *
 * @category Errors
 * @category generated
 */
class SpendingLimitInvalidAmountError extends Error {
    constructor() {
        super('Invalid SpendingLimit amount');
        this.code = 0x1797;
        this.name = 'SpendingLimitInvalidAmount';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, SpendingLimitInvalidAmountError);
        }
    }
}
exports.SpendingLimitInvalidAmountError = SpendingLimitInvalidAmountError;
createErrorFromCodeLookup.set(0x1797, () => new SpendingLimitInvalidAmountError());
createErrorFromNameLookup.set('SpendingLimitInvalidAmount', () => new SpendingLimitInvalidAmountError());
/**
 * Attempts to resolve a custom program error from the provided error code.
 * @category Errors
 * @category generated
 */
function errorFromCode(code) {
    const createError = createErrorFromCodeLookup.get(code);
    return createError != null ? createError() : null;
}
exports.errorFromCode = errorFromCode;
/**
 * Attempts to resolve a custom program error from the provided error name, i.e. 'Unauthorized'.
 * @category Errors
 * @category generated
 */
function errorFromName(name) {
    const createError = createErrorFromNameLookup.get(name);
    return createError != null ? createError() : null;
}
exports.errorFromName = errorFromName;
//# sourceMappingURL=index.js.map