"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.batchCreate = void 0;
const generated_1 = require("../generated");
const pda_1 = require("../pda");
function batchCreate({ multisigPda, creator, rentPayer, batchIndex, vaultIndex, memo, programId = generated_1.PROGRAM_ID, }) {
    const [batchPda] = (0, pda_1.getTransactionPda)({
        multisigPda,
        index: batchIndex,
        programId,
    });
    return (0, generated_1.createBatchCreateInstruction)({
        multisig: multisigPda,
        creator,
        rentPayer: rentPayer !== null && rentPayer !== void 0 ? rentPayer : creator,
        batch: batchPda,
    }, { args: { vaultIndex, memo: memo !== null && memo !== void 0 ? memo : null } }, programId);
}
exports.batchCreate = batchCreate;
//# sourceMappingURL=batchCreate.js.map