"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configTransactionCreate = void 0;
const generated_1 = require("../generated");
const pda_1 = require("../pda");
function configTransactionCreate({ multisigPda, transactionIndex, creator, rentPayer, actions, memo, programId = generated_1.PROGRAM_ID, }) {
    const [transactionPda] = (0, pda_1.getTransactionPda)({
        multisigPda,
        index: transactionIndex,
        programId,
    });
    return (0, generated_1.createConfigTransactionCreateInstruction)({
        multisig: multisigPda,
        transaction: transactionPda,
        creator,
        rentPayer: rentPayer !== null && rentPayer !== void 0 ? rentPayer : creator,
    }, { args: { actions, memo: memo !== null && memo !== void 0 ? memo : null } }, programId);
}
exports.configTransactionCreate = configTransactionCreate;
//# sourceMappingURL=configTransactionCreate.js.map