"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multisigAddMember = void 0;
const web3_js_1 = require("@solana/web3.js");
const generated_1 = require("../generated");
function multisigAddMember({ multisigPda, configAuthority, rentPayer, newMember, memo, programId = generated_1.PROGRAM_ID, }) {
    return (0, generated_1.createMultisigAddMemberInstruction)({
        multisig: multisigPda,
        configAuthority,
        rentPayer,
        systemProgram: web3_js_1.SystemProgram.programId,
    }, { args: { newMember, memo: memo !== null && memo !== void 0 ? memo : null } }, programId);
}
exports.multisigAddMember = multisigAddMember;
//# sourceMappingURL=multisigAddMember.js.map