"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.multisigAddSpendingLimit = void 0;
const bn_js_1 = __importDefault(require("bn.js"));
const generated_1 = require("../generated");
function multisigAddSpendingLimit({ multisigPda, configAuthority, spendingLimit, rentPayer, createKey, vaultIndex, mint, amount, period, members, destinations, memo, programId = generated_1.PROGRAM_ID, }) {
    return (0, generated_1.createMultisigAddSpendingLimitInstruction)({
        multisig: multisigPda,
        spendingLimit,
        configAuthority,
        rentPayer,
    }, {
        args: {
            createKey,
            vaultIndex,
            mint,
            amount: new bn_js_1.default(amount.toString()),
            period,
            members,
            destinations,
            memo: memo !== null && memo !== void 0 ? memo : null,
        },
    }, programId);
}
exports.multisigAddSpendingLimit = multisigAddSpendingLimit;
//# sourceMappingURL=multisigAddSpendingLimit.js.map