"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multisigCreateV2 = void 0;
const generated_1 = require("../generated");
const pda_1 = require("../pda");
function multisigCreateV2({ treasury, creator, multisigPda, configAuthority, threshold, members, timeLock, createKey, rentCollector, memo, programId = generated_1.PROGRAM_ID, }) {
    const programConfigPda = (0, pda_1.getProgramConfigPda)({ programId })[0];
    return (0, generated_1.createMultisigCreateV2Instruction)({
        programConfig: programConfigPda,
        treasury,
        creator,
        createKey,
        multisig: multisigPda,
    }, {
        args: {
            configAuthority,
            threshold,
            members,
            timeLock,
            rentCollector,
            memo: memo !== null && memo !== void 0 ? memo : null,
        },
    }, programId);
}
exports.multisigCreateV2 = multisigCreateV2;
//# sourceMappingURL=multisigCreateV2.js.map