"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multisigSetRentCollector = void 0;
const web3_js_1 = require("@solana/web3.js");
const generated_1 = require("../generated");
function multisigSetRentCollector({ multisigPda, configAuthority, newRentCollector, rentPayer, memo, programId, }) {
    return (0, generated_1.createMultisigSetRentCollectorInstruction)({
        multisig: multisigPda,
        configAuthority,
        rentPayer,
        systemProgram: web3_js_1.SystemProgram.programId,
    }, {
        args: {
            rentCollector: newRentCollector,
            memo: memo !== null && memo !== void 0 ? memo : null,
        },
    }, programId);
}
exports.multisigSetRentCollector = multisigSetRentCollector;
//# sourceMappingURL=multisigSetRentCollector.js.map