"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.proposalCreate = void 0;
const generated_1 = require("../generated");
const pda_1 = require("../pda");
function proposalCreate({ multisigPda, creator, rentPayer, transactionIndex, isDraft = false, programId = generated_1.PROGRAM_ID, }) {
    const [proposalPda] = (0, pda_1.getProposalPda)({
        multisigPda,
        transactionIndex,
        programId,
    });
    if (transactionIndex > Number.MAX_SAFE_INTEGER) {
        throw new Error("transactionIndex is too large");
    }
    return (0, generated_1.createProposalCreateInstruction)({
        creator,
        rentPayer: rentPayer !== null && rentPayer !== void 0 ? rentPayer : creator,
        multisig: multisigPda,
        proposal: proposalPda,
    }, { args: { transactionIndex: Number(transactionIndex), draft: isDraft } }, programId);
}
exports.proposalCreate = proposalCreate;
//# sourceMappingURL=proposalCreate.js.map