"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.spendingLimitUse = void 0;
const web3_js_1 = require("@solana/web3.js");
const spl_token_1 = require("@solana/spl-token");
const generated_1 = require("../generated");
const pda_1 = require("../pda");
function spendingLimitUse({ multisigPda, member, spendingLimit, mint, vaultIndex, amount, decimals, destination, tokenProgram = spl_token_1.TOKEN_PROGRAM_ID, memo, programId = generated_1.PROGRAM_ID, }) {
    const [vaultPda] = (0, pda_1.getVaultPda)({ multisigPda, index: vaultIndex, programId });
    const vaultTokenAccount = mint &&
        (0, spl_token_1.getAssociatedTokenAddressSync)(mint, vaultPda, true, tokenProgram, spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID);
    const destinationTokenAccount = mint &&
        (0, spl_token_1.getAssociatedTokenAddressSync)(mint, destination, true, tokenProgram, spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID);
    return (0, generated_1.createSpendingLimitUseInstruction)({
        multisig: multisigPda,
        member,
        spendingLimit,
        vault: vaultPda,
        destination,
        systemProgram: web3_js_1.SystemProgram.programId,
        mint,
        vaultTokenAccount,
        destinationTokenAccount,
        tokenProgram: mint ? tokenProgram : undefined,
    }, { args: { amount, decimals, memo: memo !== null && memo !== void 0 ? memo : null } }, programId);
}
exports.spendingLimitUse = spendingLimitUse;
//# sourceMappingURL=spendingLimitUse.js.map