"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.vaultTransactionAccountsClose = void 0;
const generated_1 = require("../generated");
const pda_1 = require("../pda");
function vaultTransactionAccountsClose({ multisigPda, rentCollector, transactionIndex, programId = generated_1.PROGRAM_ID, }) {
    const [proposalPda] = (0, pda_1.getProposalPda)({
        multisigPda,
        transactionIndex,
        programId,
    });
    const [transactionPda] = (0, pda_1.getTransactionPda)({
        multisigPda,
        index: transactionIndex,
        programId,
    });
    return (0, generated_1.createVaultTransactionAccountsCloseInstruction)({
        multisig: multisigPda,
        rentCollector,
        proposal: proposalPda,
        transaction: transactionPda,
    }, programId);
}
exports.vaultTransactionAccountsClose = vaultTransactionAccountsClose;
//# sourceMappingURL=vaultTransactionAccountsClose.js.map