"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.batchCreate = void 0;
const transactions = __importStar(require("../transactions"));
const errors_1 = require("../errors");
/** Create a new vault transactions batch. */
function batchCreate({ connection, feePayer, multisigPda, batchIndex, creator, rentPayer, vaultIndex, memo, signers, sendOptions, programId, }) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const blockhash = (yield connection.getLatestBlockhash()).blockhash;
        const tx = transactions.batchCreate({
            blockhash,
            feePayer: feePayer.publicKey,
            multisigPda,
            batchIndex,
            creator: creator.publicKey,
            rentPayer: (_a = rentPayer === null || rentPayer === void 0 ? void 0 : rentPayer.publicKey) !== null && _a !== void 0 ? _a : creator.publicKey,
            vaultIndex,
            memo,
            programId,
        });
        const allSigners = [feePayer, creator];
        if (signers) {
            allSigners.push(...signers);
        }
        if (rentPayer) {
            allSigners.push(rentPayer);
        }
        tx.sign(allSigners);
        try {
            return yield connection.sendTransaction(tx, sendOptions);
        }
        catch (err) {
            (0, errors_1.translateAndThrowAnchorError)(err);
        }
    });
}
exports.batchCreate = batchCreate;
//# sourceMappingURL=batchCreate.js.map