"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.batchCreate = void 0;
const web3_js_1 = require("@solana/web3.js");
const instructions = __importStar(require("../instructions"));
/**
 * Returns unsigned `VersionedTransaction` that needs to be
 * signed by `creator` and `feePayer` before sending it.
 */
function batchCreate({ blockhash, feePayer, multisigPda, batchIndex, creator, rentPayer, vaultIndex, memo, programId, }) {
    const message = new web3_js_1.TransactionMessage({
        payerKey: feePayer,
        recentBlockhash: blockhash,
        instructions: [
            instructions.batchCreate({
                multisigPda,
                creator,
                rentPayer: rentPayer !== null && rentPayer !== void 0 ? rentPayer : creator,
                batchIndex,
                vaultIndex,
                memo,
                programId,
            }),
        ],
    }).compileToV0Message();
    return new web3_js_1.VersionedTransaction(message);
}
exports.batchCreate = batchCreate;
//# sourceMappingURL=batchCreate.js.map