import { initCusper } from "@metaplex-foundation/cusper";
import { errorFromCode } from "./generated";
const cusper = initCusper(errorFromCode);
export function translateAndThrowAnchorError(err) {
    if (!isErrorWithLogs(err)) {
        throw err;
    }
    const translatedError = cusper.errorFromProgramLogs(err.logs) ?? err;
    if (typeof Error.captureStackTrace === "function") {
        Error.captureStackTrace(translatedError, translateAndThrowAnchorError);
    }
    translatedError.logs = err.logs;
    throw translatedError;
}
export const isErrorWithLogs = (err) => {
    return Boolean(err && typeof err === "object" && "logs" in err && Array.isArray(err.logs));
};
//# sourceMappingURL=errors.js.map