import { createBatchCreateInstruction, PROGRAM_ID } from "../generated";
import { getTransactionPda } from "../pda";
export function batchCreate({ multisigPda, creator, rentPayer, batchIndex, vaultIndex, memo, programId = PROGRAM_ID, }) {
    const [batchPda] = getTransactionPda({
        multisigPda,
        index: batchIndex,
        programId,
    });
    return createBatchCreateInstruction({
        multisig: multisigPda,
        creator,
        rentPayer: rentPayer ?? creator,
        batch: batchPda,
    }, { args: { vaultIndex, memo: memo ?? null } }, programId);
}
//# sourceMappingURL=batchCreate.js.map