import { createConfigTransactionCreateInstruction, PROGRAM_ID, } from "../generated";
import { getTransactionPda } from "../pda";
export function configTransactionCreate({ multisigPda, transactionIndex, creator, rentPayer, actions, memo, programId = PROGRAM_ID, }) {
    const [transactionPda] = getTransactionPda({
        multisigPda,
        index: transactionIndex,
        programId,
    });
    return createConfigTransactionCreateInstruction({
        multisig: multisigPda,
        transaction: transactionPda,
        creator,
        rentPayer: rentPayer ?? creator,
    }, { args: { actions, memo: memo ?? null } }, programId);
}
//# sourceMappingURL=configTransactionCreate.js.map