import BN from "bn.js";
import { createMultisigAddSpendingLimitInstruction, PROGRAM_ID, } from "../generated";
export function multisigAddSpendingLimit({ multisigPda, configAuthority, spendingLimit, rentPayer, createKey, vaultIndex, mint, amount, period, members, destinations, memo, programId = PROGRAM_ID, }) {
    return createMultisigAddSpendingLimitInstruction({
        multisig: multisigPda,
        spendingLimit,
        configAuthority,
        rentPayer,
    }, {
        args: {
            createKey,
            vaultIndex,
            mint,
            amount: new BN(amount.toString()),
            period,
            members,
            destinations,
            memo: memo ?? null,
        },
    }, programId);
}
//# sourceMappingURL=multisigAddSpendingLimit.js.map