import { createMultisigCreateV2Instruction, PROGRAM_ID, } from "../generated";
import { getProgramConfigPda } from "../pda";
export function multisigCreateV2({ treasury, creator, multisigPda, configAuthority, threshold, members, timeLock, createKey, rentCollector, memo, programId = PROGRAM_ID, }) {
    const programConfigPda = getProgramConfigPda({ programId })[0];
    return createMultisigCreateV2Instruction({
        programConfig: programConfigPda,
        treasury,
        creator,
        createKey,
        multisig: multisigPda,
    }, {
        args: {
            configAuthority,
            threshold,
            members,
            timeLock,
            rentCollector,
            memo: memo ?? null,
        },
    }, programId);
}
//# sourceMappingURL=multisigCreateV2.js.map