import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
/** Create a new config transaction. */
export async function configTransactionCreate({ connection, feePayer, multisigPda, transactionIndex, creator, rentPayer, actions, memo, signers, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.configTransactionCreate({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        transactionIndex,
        creator,
        rentPayer,
        actions,
        memo,
        programId,
    });
    tx.sign([feePayer, ...(signers ?? [])]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=configTransactionCreate.js.map