import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
/** Execute a config transaction. */
export async function configTransactionExecute({ connection, feePayer, multisigPda, transactionIndex, member, rentPayer, spendingLimits, signers, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.configTransactionExecute({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        transactionIndex,
        member: member.publicKey,
        rentPayer: rentPayer.publicKey,
        spendingLimits,
        programId,
    });
    tx.sign([feePayer, member, rentPayer, ...(signers ?? [])]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=configTransactionExecute.js.map