import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
/**
 * @deprecated This instruction is deprecated and will be removed soon. Please use `multisigCreateV2` to ensure future compatibility.
 *
 * Creates a new multisig.
 */
export async function multisigCreate({ connection, createKey, creator, multisigPda, configAuthority, threshold, members, timeLock, memo, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.multisigCreate({
        blockhash,
        createKey: createKey.publicKey,
        creator: creator.publicKey,
        multisigPda,
        configAuthority,
        threshold,
        members,
        timeLock,
        memo,
        programId,
    });
    tx.sign([creator, createKey]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=multisigCreate.js.map