import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
/** Creates a new multisig. */
export async function multisigCreateV2({ connection, treasury, createKey, creator, multisigPda, configAuthority, threshold, members, timeLock, rentCollector, memo, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.multisigCreateV2({
        blockhash,
        treasury,
        createKey: createKey.publicKey,
        creator: creator.publicKey,
        multisigPda,
        configAuthority,
        threshold,
        members,
        timeLock,
        rentCollector,
        memo,
        programId,
    });
    tx.sign([creator, createKey]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=multisigCreateV2.js.map