import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
/** Set the multisig `config_authority`. */
export async function multisigSetConfigAuthority({ connection, feePayer, multisigPda, configAuthority, newConfigAuthority, memo, signers, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.multisigSetConfigAuthority({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        configAuthority,
        newConfigAuthority,
        memo,
        programId,
    });
    tx.sign([feePayer, ...(signers ?? [])]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=multisigSetConfigAuthority.js.map