import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
/** Set the `time_lock` config parameter for the multisig. */
export async function multisigSetTimeLock({ connection, feePayer, multisigPda, configAuthority, timeLock, memo, signers, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.multisigSetTimeLock({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        configAuthority,
        timeLock,
        memo,
        programId,
    });
    tx.sign([feePayer, ...(signers ?? [])]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=multisigSetTimeLock.js.map