import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
export async function proposalActivate({ connection, feePayer, member, multisigPda, transactionIndex, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.proposalActivate({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        transactionIndex,
        member: member.publicKey,
        programId,
    });
    tx.sign([feePayer, member]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=proposalActivate.js.map