import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
export async function proposalReject({ connection, feePayer, member, multisigPda, transactionIndex, memo, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.proposalReject({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        transactionIndex,
        member: member.publicKey,
        memo,
        programId,
    });
    tx.sign([feePayer, member]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=proposalReject.js.map