import * as transactions from "../transactions";
import { translateAndThrowAnchorError } from "../errors";
export async function spendingLimitUse({ connection, feePayer, member, multisigPda, spendingLimit, mint, vaultIndex, amount, decimals, destination, tokenProgram, memo, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.spendingLimitUse({
        blockhash,
        feePayer: feePayer.publicKey,
        multisigPda,
        member: member.publicKey,
        spendingLimit,
        mint,
        vaultIndex,
        amount,
        decimals,
        destination,
        tokenProgram,
        memo,
        programId,
    });
    tx.sign([feePayer, member]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=spendingLimitUse.js.map