import * as transactions from "../transactions/index.js";
import { translateAndThrowAnchorError } from "../errors";
/**
 * Close the Proposal and ConfigTransaction accounts associated with a config transaction.
 */
export async function vaultTransactionAccountsClose({ connection, feePayer, multisigPda, rentCollector, transactionIndex, sendOptions, programId, }) {
    const blockhash = (await connection.getLatestBlockhash()).blockhash;
    const tx = transactions.vaultTransactionAccountsClose({
        blockhash,
        feePayer: feePayer.publicKey,
        rentCollector,
        transactionIndex,
        multisigPda,
        programId,
    });
    tx.sign([feePayer]);
    try {
        return await connection.sendTransaction(tx, sendOptions);
    }
    catch (err) {
        translateAndThrowAnchorError(err);
    }
}
//# sourceMappingURL=vaultTransactionAccountsClose.js.map