import { TransactionMessage, VersionedTransaction, } from "@solana/web3.js";
import * as instructions from "../instructions/index.js";
export function configTransactionAccountsClose({ blockhash, feePayer, multisigPda, rentCollector, transactionIndex, programId, }) {
    const message = new TransactionMessage({
        payerKey: feePayer,
        recentBlockhash: blockhash,
        instructions: [
            instructions.configTransactionAccountsClose({
                multisigPda,
                rentCollector,
                transactionIndex,
                programId,
            }),
        ],
    }).compileToV0Message();
    return new VersionedTransaction(message);
}
//# sourceMappingURL=configTransactionAccountsClose.js.map