import { TransactionMessage, VersionedTransaction, } from "@solana/web3.js";
import * as instructions from "../instructions";
/**
 * Returns unsigned `VersionedTransaction` that needs to be
 * signed by `creator` and `feePayer` before sending it.
 */
export function configTransactionExecute({ blockhash, feePayer, multisigPda, member, rentPayer, transactionIndex, spendingLimits, programId, }) {
    const message = new TransactionMessage({
        payerKey: feePayer,
        recentBlockhash: blockhash,
        instructions: [
            instructions.configTransactionExecute({
                multisigPda,
                transactionIndex,
                member,
                rentPayer,
                spendingLimits,
                programId,
            }),
        ],
    }).compileToV0Message();
    return new VersionedTransaction(message);
}
//# sourceMappingURL=configTransactionExecute.js.map