import { TransactionMessage, VersionedTransaction, } from "@solana/web3.js";
import * as instructions from "../instructions";
/**
 * Returns unsigned `VersionedTransaction` that needs to be
 * signed by `configAuthority` and `feePayer` before sending it.
 */
export function multisigSetRentCollector({ blockhash, feePayer, multisigPda, configAuthority, newRentCollector, rentPayer, memo, programId, }) {
    const message = new TransactionMessage({
        payerKey: feePayer,
        recentBlockhash: blockhash,
        instructions: [
            instructions.multisigSetRentCollector({
                multisigPda,
                configAuthority,
                newRentCollector,
                rentPayer,
                memo,
                programId,
            }),
        ],
    }).compileToV0Message();
    return new VersionedTransaction(message);
}
//# sourceMappingURL=multisigSetRentCollector.js.map