import { TransactionMessage, VersionedTransaction, } from "@solana/web3.js";
import * as instructions from "../instructions/index.js";
export function vaultTransactionAccountsClose({ blockhash, feePayer, multisigPda, rentCollector, transactionIndex, programId, }) {
    const message = new TransactionMessage({
        payerKey: feePayer,
        recentBlockhash: blockhash,
        instructions: [
            instructions.vaultTransactionAccountsClose({
                multisigPda,
                rentCollector,
                transactionIndex,
                programId,
            }),
        ],
    }).compileToV0Message();
    return new VersionedTransaction(message);
}
//# sourceMappingURL=vaultTransactionAccountsClose.js.map