/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
/**
 * Arguments used to create {@link Batch}
 * @category Accounts
 * @category generated
 */
export type BatchArgs = {
    multisig: web3.PublicKey;
    creator: web3.PublicKey;
    index: beet.bignum;
    bump: number;
    vaultIndex: number;
    vaultBump: number;
    size: number;
    executedTransactionIndex: number;
};
export declare const batchDiscriminator: number[];
/**
 * Holds the data for the {@link Batch} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class Batch implements BatchArgs {
    readonly multisig: web3.PublicKey;
    readonly creator: web3.PublicKey;
    readonly index: beet.bignum;
    readonly bump: number;
    readonly vaultIndex: number;
    readonly vaultBump: number;
    readonly size: number;
    readonly executedTransactionIndex: number;
    private constructor();
    /**
     * Creates a {@link Batch} instance from the provided args.
     */
    static fromArgs(args: BatchArgs): Batch;
    /**
     * Deserializes the {@link Batch} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [Batch, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link Batch} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<Batch>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        multisig: any;
        creator: any;
        index: any;
        bump: any;
        vaultIndex: any;
        vaultBump: any;
        size: any;
        executedTransactionIndex: any;
    }>;
    /**
     * Deserializes the {@link Batch} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [Batch, number];
    /**
     * Serializes the {@link Batch} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link Batch}
     */
    static get byteSize(): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link Batch} data from rent
     *
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Determines if the provided {@link Buffer} has the correct byte size to
     * hold {@link Batch} data.
     */
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    /**
     * Returns a readable version of {@link Batch} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        multisig: string;
        creator: string;
        index: number | {
            toNumber: () => number;
        };
        bump: number;
        vaultIndex: number;
        vaultBump: number;
        size: number;
        executedTransactionIndex: number;
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const batchBeet: beet.BeetStruct<Batch, BatchArgs & {
    accountDiscriminator: number[];
}>;
//# sourceMappingURL=Batch.d.ts.map