/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
import { ConfigAction } from '../types/ConfigAction';
/**
 * Arguments used to create {@link ConfigTransaction}
 * @category Accounts
 * @category generated
 */
export type ConfigTransactionArgs = {
    multisig: web3.PublicKey;
    creator: web3.PublicKey;
    index: beet.bignum;
    bump: number;
    actions: ConfigAction[];
};
export declare const configTransactionDiscriminator: number[];
/**
 * Holds the data for the {@link ConfigTransaction} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class ConfigTransaction implements ConfigTransactionArgs {
    readonly multisig: web3.PublicKey;
    readonly creator: web3.PublicKey;
    readonly index: beet.bignum;
    readonly bump: number;
    readonly actions: ConfigAction[];
    private constructor();
    /**
     * Creates a {@link ConfigTransaction} instance from the provided args.
     */
    static fromArgs(args: ConfigTransactionArgs): ConfigTransaction;
    /**
     * Deserializes the {@link ConfigTransaction} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [ConfigTransaction, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link ConfigTransaction} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<ConfigTransaction>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        multisig: any;
        creator: any;
        index: any;
        bump: any;
        actions: any;
    }>;
    /**
     * Deserializes the {@link ConfigTransaction} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [ConfigTransaction, number];
    /**
     * Serializes the {@link ConfigTransaction} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link ConfigTransaction} for the provided args.
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     */
    static byteSize(args: ConfigTransactionArgs): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link ConfigTransaction} data from rent
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(args: ConfigTransactionArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Returns a readable version of {@link ConfigTransaction} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        multisig: string;
        creator: string;
        index: number | {
            toNumber: () => number;
        };
        bump: number;
        actions: ConfigAction[];
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const configTransactionBeet: beet.FixableBeetStruct<ConfigTransaction, ConfigTransactionArgs & {
    accountDiscriminator: number[];
}>;
//# sourceMappingURL=ConfigTransaction.d.ts.map