/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
import { Member } from '../types/Member';
/**
 * Arguments used to create {@link Multisig}
 * @category Accounts
 * @category generated
 */
export type MultisigArgs = {
    createKey: web3.PublicKey;
    configAuthority: web3.PublicKey;
    threshold: number;
    timeLock: number;
    transactionIndex: beet.bignum;
    staleTransactionIndex: beet.bignum;
    rentCollector: beet.COption<web3.PublicKey>;
    bump: number;
    members: Member[];
};
export declare const multisigDiscriminator: number[];
/**
 * Holds the data for the {@link Multisig} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class Multisig implements MultisigArgs {
    readonly createKey: web3.PublicKey;
    readonly configAuthority: web3.PublicKey;
    readonly threshold: number;
    readonly timeLock: number;
    readonly transactionIndex: beet.bignum;
    readonly staleTransactionIndex: beet.bignum;
    readonly rentCollector: beet.COption<web3.PublicKey>;
    readonly bump: number;
    readonly members: Member[];
    private constructor();
    /**
     * Creates a {@link Multisig} instance from the provided args.
     */
    static fromArgs(args: MultisigArgs): Multisig;
    /**
     * Deserializes the {@link Multisig} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [Multisig, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link Multisig} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<Multisig>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        bump: any;
        createKey: any;
        members: any;
        configAuthority: any;
        threshold: any;
        timeLock: any;
        transactionIndex: any;
        staleTransactionIndex: any;
        rentCollector: any;
    }>;
    /**
     * Deserializes the {@link Multisig} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [Multisig, number];
    /**
     * Serializes the {@link Multisig} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link Multisig} for the provided args.
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     */
    static byteSize(args: MultisigArgs): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link Multisig} data from rent
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(args: MultisigArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Returns a readable version of {@link Multisig} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        createKey: string;
        configAuthority: string;
        threshold: number;
        timeLock: number;
        transactionIndex: number | {
            toNumber: () => number;
        };
        staleTransactionIndex: number | {
            toNumber: () => number;
        };
        rentCollector: web3.PublicKey;
        bump: number;
        members: Member[];
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const multisigBeet: beet.FixableBeetStruct<Multisig, MultisigArgs & {
    accountDiscriminator: number[];
}>;
//# sourceMappingURL=Multisig.d.ts.map