/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
import { ProposalStatus } from '../types/ProposalStatus';
/**
 * Arguments used to create {@link Proposal}
 * @category Accounts
 * @category generated
 */
export type ProposalArgs = {
    multisig: web3.PublicKey;
    transactionIndex: beet.bignum;
    status: ProposalStatus;
    bump: number;
    approved: web3.PublicKey[];
    rejected: web3.PublicKey[];
    cancelled: web3.PublicKey[];
};
export declare const proposalDiscriminator: number[];
/**
 * Holds the data for the {@link Proposal} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class Proposal implements ProposalArgs {
    readonly multisig: web3.PublicKey;
    readonly transactionIndex: beet.bignum;
    readonly status: ProposalStatus;
    readonly bump: number;
    readonly approved: web3.PublicKey[];
    readonly rejected: web3.PublicKey[];
    readonly cancelled: web3.PublicKey[];
    private constructor();
    /**
     * Creates a {@link Proposal} instance from the provided args.
     */
    static fromArgs(args: ProposalArgs): Proposal;
    /**
     * Deserializes the {@link Proposal} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [Proposal, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link Proposal} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<Proposal>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        multisig: any;
        bump: any;
        transactionIndex: any;
        status: any;
        approved: any;
        rejected: any;
        cancelled: any;
    }>;
    /**
     * Deserializes the {@link Proposal} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [Proposal, number];
    /**
     * Serializes the {@link Proposal} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link Proposal} for the provided args.
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     */
    static byteSize(args: ProposalArgs): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link Proposal} data from rent
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(args: ProposalArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Returns a readable version of {@link Proposal} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        multisig: string;
        transactionIndex: number | {
            toNumber: () => number;
        };
        status: "Draft" | "Active" | "Rejected" | "Approved" | "Executing" | "Executed" | "Cancelled";
        bump: number;
        approved: web3.PublicKey[];
        rejected: web3.PublicKey[];
        cancelled: web3.PublicKey[];
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const proposalBeet: beet.FixableBeetStruct<Proposal, ProposalArgs & {
    accountDiscriminator: number[];
}>;
//# sourceMappingURL=Proposal.d.ts.map