/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
import { Period } from '../types/Period';
/**
 * Arguments used to create {@link SpendingLimit}
 * @category Accounts
 * @category generated
 */
export type SpendingLimitArgs = {
    multisig: web3.PublicKey;
    createKey: web3.PublicKey;
    vaultIndex: number;
    mint: web3.PublicKey;
    amount: beet.bignum;
    period: Period;
    remainingAmount: beet.bignum;
    lastReset: beet.bignum;
    bump: number;
    members: web3.PublicKey[];
    destinations: web3.PublicKey[];
};
export declare const spendingLimitDiscriminator: number[];
/**
 * Holds the data for the {@link SpendingLimit} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class SpendingLimit implements SpendingLimitArgs {
    readonly multisig: web3.PublicKey;
    readonly createKey: web3.PublicKey;
    readonly vaultIndex: number;
    readonly mint: web3.PublicKey;
    readonly amount: beet.bignum;
    readonly period: Period;
    readonly remainingAmount: beet.bignum;
    readonly lastReset: beet.bignum;
    readonly bump: number;
    readonly members: web3.PublicKey[];
    readonly destinations: web3.PublicKey[];
    private constructor();
    /**
     * Creates a {@link SpendingLimit} instance from the provided args.
     */
    static fromArgs(args: SpendingLimitArgs): SpendingLimit;
    /**
     * Deserializes the {@link SpendingLimit} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [SpendingLimit, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link SpendingLimit} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<SpendingLimit>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        multisig: any;
        bump: any;
        vaultIndex: any;
        createKey: any;
        mint: any;
        amount: any;
        period: any;
        members: any;
        destinations: any;
        remainingAmount: any;
        lastReset: any;
    }>;
    /**
     * Deserializes the {@link SpendingLimit} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [SpendingLimit, number];
    /**
     * Serializes the {@link SpendingLimit} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link SpendingLimit} for the provided args.
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     */
    static byteSize(args: SpendingLimitArgs): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link SpendingLimit} data from rent
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(args: SpendingLimitArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Returns a readable version of {@link SpendingLimit} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        multisig: string;
        createKey: string;
        vaultIndex: number;
        mint: string;
        amount: number | {
            toNumber: () => number;
        };
        period: string;
        remainingAmount: number | {
            toNumber: () => number;
        };
        lastReset: number | {
            toNumber: () => number;
        };
        bump: number;
        members: web3.PublicKey[];
        destinations: web3.PublicKey[];
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const spendingLimitBeet: beet.FixableBeetStruct<SpendingLimit, SpendingLimitArgs & {
    accountDiscriminator: number[];
}>;
//# sourceMappingURL=SpendingLimit.d.ts.map