/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
/// <reference types="node" />
import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
import * as beetSolana from '@metaplex-foundation/beet-solana';
import { VaultTransactionMessage } from '../types/VaultTransactionMessage';
/**
 * Arguments used to create {@link VaultBatchTransaction}
 * @category Accounts
 * @category generated
 */
export type VaultBatchTransactionArgs = {
    bump: number;
    ephemeralSignerBumps: Uint8Array;
    message: VaultTransactionMessage;
};
export declare const vaultBatchTransactionDiscriminator: number[];
/**
 * Holds the data for the {@link VaultBatchTransaction} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class VaultBatchTransaction implements VaultBatchTransactionArgs {
    readonly bump: number;
    readonly ephemeralSignerBumps: Uint8Array;
    readonly message: VaultTransactionMessage;
    private constructor();
    /**
     * Creates a {@link VaultBatchTransaction} instance from the provided args.
     */
    static fromArgs(args: VaultBatchTransactionArgs): VaultBatchTransaction;
    /**
     * Deserializes the {@link VaultBatchTransaction} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [VaultBatchTransaction, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link VaultBatchTransaction} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<VaultBatchTransaction>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        bump: any;
        ephemeralSignerBumps: any;
        message: any;
    }>;
    /**
     * Deserializes the {@link VaultBatchTransaction} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [VaultBatchTransaction, number];
    /**
     * Serializes the {@link VaultBatchTransaction} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link VaultBatchTransaction} for the provided args.
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     */
    static byteSize(args: VaultBatchTransactionArgs): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link VaultBatchTransaction} data from rent
     *
     * @param args need to be provided since the byte size for this account
     * depends on them
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(args: VaultBatchTransactionArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Returns a readable version of {@link VaultBatchTransaction} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        bump: number;
        ephemeralSignerBumps: Uint8Array;
        message: VaultTransactionMessage;
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const vaultBatchTransactionBeet: beet.FixableBeetStruct<VaultBatchTransaction, VaultBatchTransactionArgs & {
    accountDiscriminator: number[];
}>;
//# sourceMappingURL=VaultBatchTransaction.d.ts.map