import { Connection, PublicKey, SendOptions, Signer, TransactionSignature } from "@solana/web3.js";
import { Period } from "../generated";
/**
 * Create a new spending limit for the controlled multisig.
 */
export declare function multisigAddSpendingLimit({ connection, feePayer, multisigPda, configAuthority, spendingLimit, rentPayer, createKey, vaultIndex, mint, amount, period, members, destinations, memo, signers, sendOptions, programId, }: {
    connection: Connection;
    feePayer: Signer;
    multisigPda: PublicKey;
    spendingLimit: PublicKey;
    configAuthority: PublicKey;
    rentPayer: Signer;
    createKey: PublicKey;
    vaultIndex: number;
    mint: PublicKey;
    amount: bigint;
    period: Period;
    members: PublicKey[];
    destinations: PublicKey[];
    memo?: string;
    signers?: Signer[];
    sendOptions?: SendOptions;
    programId?: PublicKey;
}): Promise<TransactionSignature>;
//# sourceMappingURL=multisigAddSpendingLimit.d.ts.map