import { PublicKey, VersionedTransaction } from "@solana/web3.js";
import { ConfigAction } from "../generated";
/**
 * Returns unsigned `VersionedTransaction` that needs to be
 * signed by `creator` and `feePayer` before sending it.
 */
export declare function configTransactionCreate({ blockhash, feePayer, creator, rentPayer, multisigPda, transactionIndex, actions, memo, programId, }: {
    blockhash: string;
    feePayer: PublicKey;
    /** Member of the multisig that is creating the transaction. */
    creator: PublicKey;
    /** Payer for the transaction account rent. If not provided, `creator` is used. */
    rentPayer?: PublicKey;
    multisigPda: PublicKey;
    transactionIndex: bigint;
    actions: ConfigAction[];
    memo?: string;
    programId?: PublicKey;
}): VersionedTransaction;
//# sourceMappingURL=configTransactionCreate.d.ts.map