import { PublicKey, VersionedTransaction } from "@solana/web3.js";
import { Period } from "../generated";
/**
 * Returns unsigned `VersionedTransaction` that needs to be
 * signed by `configAuthority`, `rent_payer` and `feePayer` before sending it.
 */
export declare function multisigAddSpendingLimit({ blockhash, feePayer, multisigPda, configAuthority, spendingLimit, rentPayer, createKey, vaultIndex, mint, amount, period, members, destinations, memo, programId, }: {
    blockhash: string;
    feePayer: PublicKey;
    multisigPda: PublicKey;
    spendingLimit: PublicKey;
    configAuthority: PublicKey;
    rentPayer: PublicKey;
    createKey: PublicKey;
    vaultIndex: number;
    mint: PublicKey;
    amount: bigint;
    period: Period;
    members: PublicKey[];
    destinations: PublicKey[];
    memo?: string;
    programId?: PublicKey;
}): VersionedTransaction;
//# sourceMappingURL=multisigAddSpendingLimit.d.ts.map