import { PublicKey, VersionedTransaction } from "@solana/web3.js";
/**
 * Returns unsigned `VersionedTransaction` that needs to be
 * signed by `member` and `feePayer` before sending it.
 */
export declare function spendingLimitUse({ blockhash, feePayer, multisigPda, member, spendingLimit, mint, vaultIndex, amount, decimals, destination, tokenProgram, memo, programId, }: {
    blockhash: string;
    feePayer: PublicKey;
    multisigPda: PublicKey;
    member: PublicKey;
    spendingLimit: PublicKey;
    /** Provide if `spendingLimit` is for an SPL token, omit if it's for SOL. */
    mint?: PublicKey;
    vaultIndex: number;
    amount: number;
    decimals: number;
    destination: PublicKey;
    tokenProgram?: PublicKey;
    memo?: string;
    programId?: PublicKey;
}): VersionedTransaction;
//# sourceMappingURL=spendingLimitUse.d.ts.map